!$    use OMP_LIB
      use MPI
      use eigen_libs
      implicit double precision (a-h,o-z)

      real(8), pointer ::
     &           a(:,:),z(:,:),w(:)

      real(8), parameter :: ONE = 1D0
      real(8) :: PAI, EPS, EPS2, EPS4
!
      integer :: x_nnod, y_nnod, x_inod, y_inod
!
      call mpi_init_thread( MPI_THREAD_MULTIPLE, i, ierr )
      call mpi_comm_rank( mpi_comm_world, i_inod, ierr )
      call mpi_comm_size( mpi_comm_world, i_nnod, ierr )
*
!      call eigen_init( MPI_COMM_WORLD, order='R' )
!      call eigen_init( MPI_COMM_WORLD, order='C' )
!      call eigen_init( MPI_COMM_WORLD )
!      call eigen_init( order='R' )
      call eigen_init( )

      call eigen_get_procs( nnod, x_nnod, y_nnod )
      call eigen_get_id   ( inod, x_inod, y_inod )

      if ( i_inod == 0 ) then
         open(10,file='IN')
      end if
*
      m = 48; nall = 2; mtype = 2

      PAI = 4*ATAN(ONE)
      EPS = machine_epsilon()
      EPS2 = SQRT(EPS)
      EPS4 = SQRT(EPS2)
!
      DO

         if ( i_inod == 0 ) then
            read(10,*) n0, m, nall, mtype
         end if

         call mpi_bcast(n0,1,mpi_integer,0,MPI_COMM_WORLD,ierr)
         if ( n0 < 1 ) EXIT
         call mpi_bcast(m,1,mpi_integer,0,MPI_COMM_WORLD,ierr)
         call mpi_bcast(nall,1,mpi_integer,0,MPI_COMM_WORLD,ierr)
         call mpi_bcast(mtype,1,mpi_integer,0,MPI_COMM_WORLD,ierr)

         n = n0
         nall = 6

         call eigen_get_matdims( n, nm, ny )

         allocate(
     &               a(nm, ny),
     &               z(nm, ny),
     &               w(n),
     &               stat=istat)
         if ( istat /= 0 ) then
            print*,"Memory exhausted"
            call flush(6)
            EXIT
         end if
*
         call mat_set( n, a(1,1), nm, mtype )
*-
         i =  eigen_memory_internal( n, nm, nm, m, 128 )

         call MPI_BARRIER( MPI_COMM_WORLD, ierr )
         d1 = MPI_WTIME( )
         call eigen_sx( n, n, a, nm, w, z, nm,
     &                  m_forward=m, m_backward=128, mode='X' )
         call MPI_BARRIER( MPI_COMM_WORLD, ierr )
         d2 = MPI_WTIME( )
*-
         if ( i_inod == 0 ) then
         print*,"======================================================"
            print*,"NUM.OF.PROCESS=",nnod,"(",x_nnod,y_nnod,")"
!$OMP PARALLEL
!$OMP MASTER
!$          print*,"NUM.OF.THREADS=",omp_get_num_threads()
!$OMP END MASTER
!$OMP END PARALLEL
            print*,"Matrix dimension = ",N
            select case(mtype)
            case (0)
               print*,"Matrix type = ",mtype," (Frank matrix)"
            case (1)
               print*,"Matrix type = ",mtype," (Toeplitz matrix)"
            case (2)
               print*,"Matrix type = ",mtype," (Random matrix)"
            case (3)
               print*,"Matrix type = ",mtype," (Frank matrix 2)"
            end select
            print*,"Internally required memory = ",i," [Byte]"
            print*,"Elapsed time = ",d2-d1," [sec]"
         end if
*-
         if ( IAND(nall, 4) /= 0 ) then
*-
         if ( i_inod == 0 ) then
         print*,"-----------------------------------------------"
         end if
         if ( mtype == 0 .OR. mtype == 3 ) then
         if ( i_inod == 0 ) then
            ax=0D0
            do i = 1, n
               j = n-i
               theta = PAI*(2*j+1)/(2*n+1)
               x = 5D-1/(1D0-COS(theta))
               y = ABS(w(i)-x)/ABS(x)
               if ( ax < y ) then
                  ax = MAX(ax,y)
                  k = i
               end if
            end do
            print*, "max|w(i)-w(i).true|/|w.true|=", ax, k
            if ( ax < EPS2 ) then
            print*, "*** Eigenvalue Error Test *** : PASSED"
            else if ( ax < EPS4 ) then
            print*, "*** Eigenvalue Error Test *** : CAUTION"
            else
            print*, "*** Eigenvalue Error Test *** : FAILED"
            end if
         end if
         end if
         call flush( 6 )
*-
            call mat_set( n, a(1,1), nm, mtype )
            call ev_test( n, a(1,1), nm, w(1), z(1,1), nm, t )
         if ( i_inod == 0 ) then
         print*,"-----------------------------------------------"
         end if
         end if
*
         if ( i_inod == 0 ) then
         print*,"======================================================"
         print*,""
         end if
*
         deallocate( a, z, w )

      END DO

      if ( i_inod == 0 ) then
         close(10)
      end if
*
      call eigen_free( )
*
      call MPI_Finalize( ierr )
      end

      subroutine flush( i )
      end

